unit screen;     { a collection of screen orientated procs and funcs }
{ Written by Hunter Beanland - www.geocities.com/hbeanland }

interface

uses crt,dos,tools;
var video:longint;
var ly,lx,cutop,cubot,cux,cuy,vidpg:integer;

procedure scrn(xx,yy,cha:integer);
procedure scr(xx,yy,cha,fore,bac:integer);
procedure writehorz(cha,times:integer);                  { from cursor }
procedure writevert(cha,times:integer);
procedure cumod(top,bot:integer);                        { top=0, bot=13 }
procedure cuget;                                         { stor cutop,cubot }
procedure scrnsize;                                      { stor lx,ly }
procedure bordercolor(col:integer);
procedure scroll(dir:string; tx,ty,bx,by,nol,col:integer);  { dir=UP|DO }
procedure greyscale(onoff:boolean);
procedure vidtype(var mode:integer);   { 0,1,10..12 M, 2 C, 3..5 E, 6..9 V }
procedure getchar(xx,yy:integer; var chaa,fore,bac:integer);
function  savewin(tx,ty,bx,by:byte):pointer;
procedure restwin(xx,yy:integer; var winptr:pointer; loseit:boolean); { 0,0 for  saved pos }
procedure border(tx,ty,tw,tz,fore,bac,bord:integer);
procedure explode(x,y,w,z,fore,bac,bord:integer);
procedure implode(xx,yy,ww,zz:integer);
procedure wallpaper(fore,bac:integer);                   { col of bars }
procedure shad(x,y,w,z:integer);                         { win coords }
procedure win(x,y,w,z,fore,bac,bord:integer; explw,shadw:boolean);

implementation

procedure scrn;
begin
  mem[video:(((lx*(yy-1))+xx)*2)-2]:=cha;
  mem[video:(((lx*(yy-1))+xx)*2)-1]:=textattr;
end;

procedure scr;
begin
  mem[video:(((lx*(yy-1))+xx)*2)-1]:=(bac shl 4)+fore;
  mem[video:(((lx*(yy-1))+xx)*2)-2]:=cha;
end;

procedure writehorz;
begin
 for ii:=wherex to (wherex+times-1) do
  scrn(ii,wherey,cha);
end;

procedure writevert;
var xx:byte;
begin
 if wherey+times>ly then times:=ly-wherey+1;
 xx:=wherex;
 for ii:=wherey to (wherey+times-1) do
  scrn(xx,ii,cha);
end;

procedure cumod;
begin
 reg.ah:=$01;
 reg.bh:=vidpg;
 reg.ch:=top;
 reg.cl:=bot;
 intr($10,reg);
end;

procedure cuget;
begin
  reg.ah:=3;
  reg.bh:=vidpg;
  intr($10,reg);
  cutop:=reg.ch;
  cubot:=reg.cl;
end;

procedure scrnsize;
begin
  lx:=lo(windmax)+1;
  ly:=hi(windmax)+1;
end;

procedure bordercolor;
begin
 reg.ah:=$0b;
 reg.bh:=vidpg;
 reg.bl:=col;
 intr($10,reg);
end;

procedure scroll;
begin
 if dir='UP' then reg.ax:=$0600
 else reg.ax:=$0700;
 reg.ax:=reg.ax + nol;
 reg.bx:=col shl 8;
 reg.cx:=ty shl 8;
 reg.cx:=reg.cx + tx;
 reg.dx:=by shl 8;
 reg.dx:=reg.dx + bx;
 intr($10,reg);
end;

procedure greyscale;
begin
 if onoff then ii:=$1200
 else ii:=$1201;
asm
 mov ax,ii
 mov bl,$33
 int $10
 mov ah,$0f
 int $10
 mov ah,00
 int $10
end; end;

procedure vidtype;
begin
  reg.ax:=$1a00;
  intr($10,reg);
  mode:=reg.bl;
  if reg.al<>$1a then mode:=0;
end;

procedure getchar;
var att:byte;
begin
  att:=mem[video:(((lx*(yy-1))+xx)*2)-1];
  chaa:=mem[video:(((lx*(yy-1))+xx)*2)-2];
  bac:=att shr 4;
  fore:=(att shl 4) shr 4;
end;

function savewin;
var winarr:array[0..5] of byte;
    winptr,wptr:pointer;
    nlines,nchars:integer;
    scrofs:longint;
begin
 err:=0;
 nlines:=by-ty+1;
 nchars:=(bx-tx+1)*2;
 ii:=nlines*nchars+sizeof(winarr);
 getmem(winptr,ii);
 if winptr=nil then begin err:=1; exit; end;
 wptr:=winptr;
 scrofs:=(ty-1)*(lo(windmax)+1)*2+(tx-1)*2;
 winarr[0]:=tx;
 winarr[1]:=ty;
 winarr[2]:=bx;
 winarr[3]:=by;
 winarr[4]:=wherex;
 winarr[5]:=wherey;
 move(winarr,winptr^,sizeof(winarr));
 winptr:=pointer(longint(winptr)+sizeof(winarr));
 for ii:=1 to nlines do begin
  move(mem[video:scrofs],winptr^,nchars);
  winptr:=pointer(longint(winptr)+nchars);
  inc(scrofs,(lo(windmax)+1)*2);
 end;
 savewin:=wptr;
end;

procedure restwin;
var winarr:array[0..5] of byte;
    wptr:pointer;
    nlines,nchars,c,l:integer;
    scrofs:longint;
begin
 if winptr=nil then exit;
 wptr:=winptr;
 move(winptr^,winarr,sizeof(winarr));
 nlines:=winarr[3]-winarr[1]+1;
 nchars:=(winarr[2]-winarr[0]+1);
 l:=nlines; c:=nchars;
 if xx=0 then begin xx:=winarr[0]; yy:=winarr[1]; end;
 if (yy+nlines-1)>ly then l:=ly-yy+1;
 if (xx+nchars-1)>lx then c:=lx-xx+1;
 nchars:=nchars*2; c:=c*2;
 scrofs:=(yy-1)*(lo(windmax)+1)*2+(xx-1)*2;
 cux:=winarr[4]; cuy:=winarr[5];
 gotoxy(cux,cuy);
 winptr:=pointer(longint(winptr)+sizeof(winarr));
 for ii:=1 to l do begin
  move(winptr^,mem[video:scrofs],c);
  winptr:=pointer(longint(winptr)+nchars);
  inc(scrofs,(lo(windmax)+1)*2);
 end;
 if loseit then begin
  ii:=nlines*nchars+sizeof(winarr);
  freemem(wptr,ii);
  winptr:=nil;
 end else winptr:=wptr;
end;

procedure border;
const a:array[0..11] of integer=(217,218,191,192,196,179,188,201,187,200,205,186);
begin
 if bord=0 then exit;
 if bord=2 then ii:=6 else ii:=0;
 scr(tw,tz,a[ii],fore,bac);
 scr(tx,ty,a[ii+1],fore,bac);
 scr(tw,ty,a[ii+2],fore,bac);
 scr(tx,tz,a[ii+3],fore,bac);
 for q:=(tx+1) to (tw-1) do
  scr(q,ty,a[ii+4],fore,bac);
 for q:=(ty+1) to (tz-1) do begin
  scr(tx,q,a[ii+5],fore,bac);
  scr(tw,q,a[ii+5],fore,bac);
 end;
 for q:=(tx+1) to (tw-1) do
  scr(q,tz,a[ii+4],fore,bac);
end;

procedure explode;
var tx,ty,tw,tz,c,q,j,cx,cy:integer;
begin
 cx:=((x+w) div 2);
 cy:=((y+z) div 2);
 c:=w-cx;
 if (z-cy) > c then c:=z-cy;
 c:=(c div 4)+1;
 j:=0;
 for q:=1 to c do
 begin
  delay(30);
  j:=j+4;
  tx:=cx-j;
  ty:=cy-(j div 2);
  tw:=cx+j;
  tz:=cy+(j div 2);
  if tx<x then tx:=x;
  if ty<y then ty:=y;
  if tw>w then tw:=w;
  if tz>z then tz:=z;
  if q=c then begin
    tx:=x;
    ty:=y;
    tw:=w;
    tz:=z;
  end;
  window(tx,ty,tw,tz);
  clrscr;
  window(1,1,lx,ly);
  border(tx,ty,tw,tz,fore,bac,bord);
 end;
end;

procedure implode;
var flag:boolean;
begin
 flag:=false;
 repeat
  wait(20);
  for q:=xx to ww do
   scr(q,yy,32,0,0);
  for q:=yy to zz do
   scr(xx,q,32,0,0);
  for q:=ww downto xx do
   scr (q,zz,32,0,0);
  for q:=zz downto yy do
   scr(ww,q,32,0,0);
  if zz=yy then flag:=true;
  dec(ww); dec(zz);
  inc(xx); inc(yy);
 until flag;
 for q:=xx to zz do
  scr(q,yy,32,0,0);
end;

procedure wallpaper;
var q:integer;
begin
  textattr:=(bac shl 4)+fore;
  clrscr;
  for q:=1 to (lo(windmax)+1) do begin
   for ii:=2 to hi(windmax) do
    scr(q,ii,176,9,7);
  end;
end;

procedure shad;
var fore,bac,cc:integer;
begin
  for ii:=1 to (z-y) do begin      {vert}
   getchar(w+1,y+ii,cc,fore,bac);
   if bac>7 then bac:=8
   else bac:=0;
   fore:=8;
   scr(w+1,y+ii,cc,fore,bac);
   getchar(w+2,y+ii,cc,fore,bac);
   if bac>7 then bac:=8
   else bac:=0;
   fore:=8;
   scr(w+2,y+ii,cc,fore,bac);
  end;
  for ii:=2 to (w-x+2) do begin    {horz}
   getchar(x+ii,z+1,cc,fore,bac);
   if bac>7 then bac:=8
   else bac:=0;
   fore:=8;
   scr(x+ii,z+1,cc,fore,bac);
  end;
end;

procedure win;
begin
 textcolor(fore);
 textbackground(bac);
 if explw then explode(x,y,w,z,fore,bac,bord)
 else begin
  window(x,y,w,z);
  clrscr;
  if bord>0 then border(x,y,w,z,fore,bac,bord);
 end;
 if shadw then shad(x,y,w,z);
 window(x,y,w,z);
end;

begin                       { video initalization }
 video:=$b800;
 if lastmode=mono then video:=$b000;
 reg.ah:=$0f;
 intr($10,reg);
 vidpg:=reg.bh;
 scrnsize;
 cuget;
end.